REST API
Web API v0.2
The Access Server Web API v0.2 is available in Access Server 3.2.0 and newer. For the v0.1 reference, which covers Access Server 3.0.0–3.1.0, see Web API v0.1.
OpenVPN Access Server Web API v0.2
This API provides the functionality required to download connection profiles, manage clients, and operate the Admin Web UI programmatically.
Conventions
Element | Convention |
|---|---|
Field names | snake_case |
URLs | kebab-case |
Other identifiers | camelCase |
Swagger UI
To browse this API interactively, navigate to /api/docs on your Access Server. Ensure you've enabled access by setting openapi.web_access to 1:
sacli --key "openapi.web_access" --value 1 ConfigPutAlternatively, set this in the Admin Web UI Config Editor.
Base URLs
/apihttps://your-access-server.example.com/api/
Authentication
API Key (AuthToken)
Parameter Name: X-OpenVPN-As-AuthToken, in: header. This is an opaque token that allows using the authenticated method. The token will expire after a certain amount of time unless it is renewed through the renewal API. While we might use a JWT for this, the API consumer should not assume anything about the format or content of this string. JWT with default encryption/authentication appears not to be FIPS compatible.
API Key (ProfileDownloadToken)
Parameter Name: token, in: query. This is a string-token that can be used to download OpenVPN Connection Profile or installer file. Typically, e.g. for installer download and OpenVPN connection profile download, this token is generated as a token, that can be used only once.
HTTP Authentication, scheme: basic a basic auth with user and password. This methods uses a fairly non-standard challenge/resposne method if required that is documented under https://github.com/OpenVPN/openvpn3/blob/master/doc/webauth.md#challengeresponse-authentication
auth
Endpoints for handling authentication to the API. All successful login calls return an opaque authentication token (auth token).
authByUserAndPw
Body parameter
{
"request_admin": true,
"username": "string",
"password": "string",
"totp": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none | |
» anonymous | body | false | none | |
»» request_admin | body | boolean | false | Whether this login should request admin privileges. Without this set to true, even admin users will not be granted admin privileges after login. |
» anonymous | body | false | none | |
»» username | body | string | true | The user name for login. Note that if this is case-sensitive or not depends on the OpenVPN Access Server configuration. |
»» password | body | string | true | The password for login in clear text |
»» totp | body | string | false | Optional TOTP token for the user when wishing to do all MFA credentials in one go. |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Authentication successful. Returns user properties and an auth token. | ||
401 | MFA is required, or SAML login is expected. | Inline | |
403 | Invalid credentials or user access denied. | ||
409 | MFA enrollment is required. Returns an intermediate auth token for enrollment. |
Response Schema
Status Code 401
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» MFAChallenge | false | none | none | |
»» echo | boolean | true | none | If true, the entered code should be displayed in cleartext. Otherwise masked like a password. |
»» challenge | string | true | none | The text presented to the user when asking for the challenge. |
»» challenge_context | string | true | none | Often authentication backends require the challenge to be answered in the same session as the initial user/password. This allows tying the MFA answer to the initial authentication attempt. |
This operation does not require authentication
const inputBody = '{
"request_admin": true,
"username": "string",
"password": "string",
"totp": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json'
};
fetch('/api/auth/login/userpassword',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"user_properties": {
"requires_mfa_enrollment": true,
"user_type": "admin",
"mfa_secret": "string",
"allowed_profiles": [
"autologin"
],
"enforce_strong_passwords": true,
"allow_password_change": true
},
"username": "string",
"auth_token": "string",
"expires_after": "string",
"renewable_until": "string"
}authMFASession
Body parameter
{
"request_admin": true,
"response": "pa$$word",
"challenge_context": "FJAIIXMAIOFLGAK23",
"username": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | true | none | |
» anonymous | body | false | none | |
»» request_admin | body | boolean | false | Whether this login should request admin privileges. Without this set to true, even admin users will not be granted admin privileges after login. |
» anonymous | body | false | none | |
»» response | body | string(password) | false | the user’s response to the MFA challenge |
»» challenge_context | body | string | false | The challenge context that was in the MFAChallenge. |
»» username | body | string | true | The user name for login |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Authentication successful. | ||
403 | Invalid MFA response. |
This operation does not require authentication
const inputBody = '{
"request_admin": true,
"response": "pa$$word",
"challenge_context": "FJAIIXMAIOFLGAK23",
"username": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json'
};
fetch('/api/auth/login/mfaauth',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"user_properties": {
"requires_mfa_enrollment": true,
"user_type": "admin",
"mfa_secret": "string",
"allowed_profiles": [
"autologin"
],
"enforce_strong_passwords": true,
"allow_password_change": true
},
"username": "string",
"auth_token": "string",
"expires_after": "string",
"renewable_until": "string"
}authBySAMLAssertion
Body parameter
{
"request_admin": true,
"assertion": "string",
"relay_state": "vpnauth~nod1~Dfk3287761d"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | true | none | |
» anonymous | body | false | none | |
»» request_admin | body | boolean | false | Whether this login should request admin privileges. Without this set to true, even admin users will not be granted admin privileges after login. |
» anonymous | body | false | none | |
»» assertion | body | string(xml) | true | SAML Assertion in xml format , encoded as base64-string |
»» relay_state | body | string | false | Optional relay state identifying the type of SAML request. If not passed or empty, defaults to cws |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Authentication successful. | ||
400 | The RelayState is incorrect or the SAML assertion is invalid. | ||
401 | The authentication assertion could not be processed: the status was unhandled, unknown, or invalid. | ||
403 | Access denied due to user/account restrictions, invalid SAML config, or profile requiring user/password based authentication. |
This operation does not require authentication
const inputBody = '{
"request_admin": true,
"assertion": "string",
"relay_state": "vpnauth~nod1~Dfk3287761d"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json'
};
fetch('/api/auth/login/saml-assertion',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"user_properties": {
"requires_mfa_enrollment": true,
"user_type": "admin",
"mfa_secret": "string",
"allowed_profiles": [
"autologin"
],
"enforce_strong_passwords": true,
"allow_password_change": true
},
"username": "string",
"auth_token": "string",
"expires_after": "string",
"renewable_until": "string"
}authRenewToken
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Token renewed successfully. | ||
401 | The old token has expired and cannot be renewed. | ||
403 | Token renewal is no longer allowed. | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/auth/token/renew',
{
method: 'POST',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"auth_token": "string",
"expires_after": "string",
"renewable_until": "string"
}changePasswordLocalUser
Body parameter
{
"username": "string",
"new_password": "pa$$word",
"no_session_invalidation": true
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Password changed successfully. | Inline | |
401 | Authentication failed. | Inline | |
403 | Auth token is not recent enough, or the new password does not meet security requirements. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» detail | string | false | none | none |
Status Code 401
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» detail | string | false | none | none |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"username": "string",
"new_password": "pa$$word",
"no_session_invalidation": true
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/auth/password/change',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"detail": "string"
}enrollUserMFA
Body parameter
{
"token": "string",
"username": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | MFA enrollment was successful. | Inline | |
400 | Provided MFA token is invalid or enrollment failed for another reason. | ||
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Enumerated Values
Property | Value |
|---|---|
user_type | admin |
user_type | user |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"token": "string",
"username": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/auth/mfa/enroll',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"user_properties": {
"requires_mfa_enrollment": true,
"user_type": "admin",
"mfa_secret": "string",
"allowed_profiles": [
"autologin"
],
"enforce_strong_passwords": true,
"allow_password_change": true
},
"username": "string",
"auth_token": "string",
"expires_after": "string",
"renewable_until": "string"
}client-import-api
Endpoints used by compatible OpenVPN clients to import connection profiles from Access Server.
get__GetInstallerViaToken
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Installer file downloaded successfully. | string | |
400 | An XMLRPC-style error response for compatibility with older /rest APIs. For compatibility reasons this way of reporting errors is used. | Inline | |
404 | The requested installer file was not found on the server, or an unexpected error occurred while downloading. | None |
const headers = {
'Accept':'application/octet-stream'
};
fetch('/api/GetInstallerViaToken?installer_type=win_v3',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
token | query | string | false | One-time profile download token |
tls-cryptv2 | query | boolean | false | Set to true if the client supports TLS-Crypt v2. This setting is only indicates the capbility of the client. It can be ignored if the server sides enforce always TLS-Crypt v2 or the server configuration does not support TLS-Crypt V2. |
installer_type | query | true | Type of installer to download. |
Enumerated Values
Parameter | Value |
|---|---|
installer_type | win_v3 |
installer_type | mac_v3 |
installer_type | win |
installer_type | mac |
installer_type | ios |
installer_type | android |
installer_type | linux |
Response Schema
Status Code 400
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» Type | string | false | none | none |
» Synopsis | string | false | none | none |
» Message | string | false | none | none |
Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
200 | Content-Disposition | string | none | |
200 | Content-Length | integer | none |
To perform this operation, you must be authenticated by means of one of the following methods: ProfileDownloadToken
get__GetProfileViaToken
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Connection profile downloaded successfully. | string | |
400 | An XMLRPC-style error response for compatibility with older /rest APIs. For compatibility reasons this way of reporting errors is used. | Inline |
const headers = {
'Accept':'application/x-openvpn-profile'
};
fetch('/api/GetProfileViaToken',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});<?xml version="1.0" encoding="UTF-8" ?>
<Error>
<Type>Invalid Request</Type>
<Synopsis>REST method failed</Synopsis>
<Message>No permission to generate profile (9422)</Message>
</Error>Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
token | query | string | false | One-time profile download token |
tls-cryptv2 | query | boolean | false | Set to true if the client supports TLS-Crypt v2. This setting is only indicates the capbility of the client. It can be ignored if the server sides enforce always TLS-Crypt v2 or the server configuration does not support TLS-Crypt V2. |
Response Schema
Status Code 400
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» Type | string | false | none | none |
» Synopsis | string | false | none | none |
» Message | string | false | none | none |
Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
200 | Content-Disposition | string | none | |
200 | VPN-Session-User | string | none | |
200 | VPN-Session-Token | string | none |
To perform this operation, you must be authenticated by means of one of the following methods: ProfileDownloadToken
get__GetAutologin
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Responds with connection profile file | string | |
400 | An XMLRPC-style error response for compatibility with older /rest APIs. For compatibility reasons this way of reporting errors is used. | Inline |
const headers = {
'Accept':'application/x-openvpn-profile'
};
fetch('/api/GetAutologin',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});<?xml version="1.0" encoding="UTF-8" ?>
<Error>
<Type>Invalid Request</Type>
<Synopsis>REST method failed</Synopsis>
<Message>No permission to generate profile (9422)</Message>
</Error>Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
tls-cryptv2 | query | boolean | false | Set to true if the client supports TLS-Crypt v2. This setting is only indicates the capbility of the client. It can be ignored if the server sides enforce always TLS-Crypt v2 or the server configuration does not support TLS-Crypt V2. |
Response Schema
Status Code 400
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» Type | string | false | none | none |
» Synopsis | string | false | none | none |
» Message | string | false | none | none |
Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
200 | Content-Disposition | string | none | |
200 | VPN-Session-User | string | none | |
200 | VPN-Session-Token | string | none |
To perform this operation, you must be authenticated by means of one of the following methods: ProfileDownloadBasicAuth
get__GetUserlogin
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Userlogin connection profile downloaded successfully. | string | |
400 | An XMLRPC-style error response for compatibility with older /rest APIs. For compatibility reasons this way of reporting errors is used. | Inline |
const headers = {
'Accept':'application/x-openvpn-profile'
};
fetch('/api/GetUserlogin',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});<?xml version="1.0" encoding="UTF-8" ?>
<Error>
<Type>Invalid Request</Type>
<Synopsis>REST method failed</Synopsis>
<Message>No permission to generate profile (9422)</Message>
</Error>Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
tls-cryptv2 | query | boolean | false | Set to true if the client supports TLS-Crypt v2. This setting is only indicates the capbility of the client. It can be ignored if the server sides enforce always TLS-Crypt v2 or the server configuration does not support TLS-Crypt V2. |
device-id | query | string | false | Unique identifier for the client device. |
Response Schema
Status Code 400
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» Type | string | false | none | none |
» Synopsis | string | false | none | none |
» Message | string | false | none | none |
Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
200 | Content-Disposition | string | none | |
200 | VPN-Session-User | string | none | |
200 | VPN-Session-Token | string | none |
To perform this operation, you must be authenticated by means of one of the following methods: ProfileDownloadBasicAuth
get__GetGeneric
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Generic profile downloaded successfully. | string | |
400 | An XMLRPC-style error response for compatibility with older /rest APIs. For compatibility reasons this way of reporting errors is used. | Inline |
const headers = {
'Accept':'application/x-openvpn-profile'
};
fetch('/api/GetGeneric',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});<?xml version="1.0" encoding="UTF-8" ?>
<Error>
<Type>Invalid Request</Type>
<Synopsis>REST method failed</Synopsis>
<Message>No permission to generate profile (9422)</Message>
</Error>Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
tls-cryptv2 | query | boolean | false | Set to true if the client supports TLS-Crypt v2. This setting is only indicates the capbility of the client. It can be ignored if the server sides enforce always TLS-Crypt v2 or the server configuration does not support TLS-Crypt V2. |
Response Schema
Status Code 400
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» Type | string | false | none | none |
» Synopsis | string | false | none | none |
» Message | string | false | none | none |
Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
200 | Content-Disposition | string | none |
To perform this operation, you must be authenticated by means of one of the following methods: ProfileDownloadBasicAuth
profiletoken
Endpoints for managing profile tokens used to generate one-time import URLs. These tokens are also part of the the web-based profile import flow for OpenVPN clients.
bulktokenurldelete
Body parameter
[
"string"
]Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | array[string] | false | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
204 | Token were successfully deleted | None | |
403 | Only admin users are allowed to use this API endpoint. | ||
404 | One or more token IDs were not found. No tokens were deleted. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '[
"string"
]';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/token-url/delete',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});profile
Endpoints for managing connection profiles used by OpenVPN clients.
head__openvpn-api_profile
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
302 | Redirects to base server URL with headers in the response according to OpenVPN webauth API specification. | None |
fetch('/api/openvpn-api/profile',
{
method: 'HEAD'
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
302 | Ovpn-WebAuth | string | Token indicating if WebAuth is supported. Client uses this to trigger browser-based import. |
This operation does not require authentication
get__openvpn-api_profile
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
302 | Redirect to http://server_addres/login?relay_state=profile | None |
This operation does not require authentication
fetch('/api/openvpn-api/profile',
{
method: 'GET'
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});getprofilesuser
Body parameter
{
"page_size": 0,
"offset": 0,
"sort_by": "asc",
"order_by": "serial",
"filters": {
"username": {
"operation": "substring",
"value": "vio"
},
"serial": {
"value": 400,
"operation": "less_than"
},
"autologin": {
"value": true
},
"tls_crypt_v2": {
"value": true
},
"last_used": {
"start": "2019-08-24",
"end": "2019-08-24"
},
"not_before": {
"start": "2019-08-24",
"end": "2019-08-24"
},
"not_after": {
"start": "2019-08-24",
"end": "2019-08-24"
},
"comment": {
"operation": "substring",
"value": "vio"
},
"signing_ca_cn": {
"operation": "substring",
"value": "vio"
},
"anywhere": {
"value": "bass",
"fields": []
}
}
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Request succeeded. Returns a list of profiles matching the filter criteria. | Inline |
Response Schema
Status Code 200
A list of all or subset of profiles
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» total | integer | false | none | total number of profiles that match if pagination is not in effect, this matches the size of the provided array |
» profiles | [allOf] | false | none | [A certificate profile of a user.] |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»» anonymous | false | none | none | |
»»» serial | certificateSerial(int64) | true | none | A string representing the certificate serial number. A string is used instead of an integer to avoid issues with large values in JavaScript, which cannot reliably handle integers larger than 52 bits. |
»»» common_name | true | none | The certificate common name (CN). | |
»»» algorithm | true | none | Specifies the algorithm used for private/public key pair in an X.509 certificate. This is an identifier such as ecp384r1, secp256r1, or secp512r1. For algorithms with variable key lengths, the length is included in the name (e.g., rsa3072). | |
»»» not_before | string(date-time) | true | none | Earliest time the certificate is valid |
»»» not_after | string(date-time) | true | none | Latest time the certificate is valid |
»»» self_signed | boolean | false | none | Whether this certificate is self-signed. Typically only root CA certificates are self-signed. |
»»» signing_ca | string(int64) | false | none | The certificate authority that has signed this certificate. For self-signed certificate authorities this value is absent. This attribute is only present for certificates that are managed by the internal PKI of Access Server and the APIs that deal and return information about these. This is also represented as a string rather than integer to avoid problems with JavaScript numbers always being double. |
»»» signing_ca_cn | string | false | none | The common name of certificate authority that has signed this certificate. For self-signed certificate authorities this value is absent. This attribute is only present for certificates that are managed by the internal PKI of Access Server and the APIs that deal and return information about these. |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»» anonymous | object | false | none | A profile for a user. |
»»» device_id | string,null | false | none | Device ID, only used for server-locked v1 profiles |
»»» comment | string,null | false | none | A user-defined comment |
»»» profile_type | false | none | Specifies the connection profile type. | |
»»» tls_crypt_v2 | boolean | false | none | This profile uses tls-crypt-v2 |
»»» last_used | string,null(date) | false | none | Last date this profile was used (only date is known, there is no more granular resolution) |
»»» username | string | false | none | User’s name |
Enumerated Values
Property | Value |
|---|---|
profile_type | autologin |
profile_type | userlogin |
profile_type | generic |
profile_type | epki-generic |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"page_size": 0,
"offset": 0,
"sort_by": "asc",
"order_by": "serial",
"filters": {
"username": {
"operation": "substring",
"value": "vio"
},
"serial": {
"value": 400,
"operation": "less_than"
},
"autologin": {
"value": true
},
"tls_crypt_v2": {
"value": true
},
"last_used": {
"start": "2019-08-24",
"end": "2019-08-24"
},
"not_before": {
"start": "2019-08-24",
"end": "2019-08-24"
},
"not_after": {
"start": "2019-08-24",
"end": "2019-08-24"
},
"comment": {
"operation": "substring",
"value": "vio"
},
"signing_ca_cn": {
"operation": "substring",
"value": "vio"
},
"anywhere": {
"value": "bass",
"fields": []
}
}
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/profiles/list',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"total": 0,
"profiles": [
{
"serial": "1708464983752887'",
"common_name": "OpenVPN VPN server CA",
"algorithm": "rsa2048",
"not_before": "2020-03-27",
"not_after": "2030-03-26",
"self_signed": true,
"signing_ca": "123",
"signing_ca_cn": "RootCA",
"device_id": "string",
"comment": "My toaster running Doom",
"profile_type": "autologin",
"tls_crypt_v2": true,
"last_used": "2019-08-24",
"username": "string"
}
]
}generateUserProfile
Body parameter
{
"username": "niccolo@paganini.it",
"profile_type": "autologin",
"tls_crypt_v2": true,
"comment": "connected from my iPhone",
"ignore_missing_user": null
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none | |
» username | body | false | A case-sensitive username. If this differs from the one associated with the auth token, admin privileges may be required for certain operations. | |
» profile_type | body | true | Specifies the connection profile type. | |
» tls_crypt_v2 | body | boolean | false | The client is capable of TLS-Crypt v2 |
» comment | body | string | false | A user-defined comment |
» ignore_missing_user | body | any | false | if this is flag, which requires admin rights, is set, a profile will be created even if the specified user does not exist. |
Enumerated Values
Parameter | Value |
|---|---|
» profile_type | autologin |
» profile_type | userlogin |
» profile_type | generic |
» profile_type | epki-generic |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
201 | Profile created successfully. | string | |
403 | Profile creation not permitted. |
Response Headers
Status | Header | Type | Format | Description |
|---|---|---|---|---|
201 | Content-Disposition | string | none | |
201 | VPN-Session-User | string | none | |
201 | VPN-Session-Token | string | none |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"username": "niccolo@paganini.it",
"profile_type": "autologin",
"tls_crypt_v2": true,
"comment": "connected from my iPhone",
"ignore_missing_user": null
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/x-openvpn-profile',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/profiles/create',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});generateTokenUrl
Body parameter
{
"lifetime": 1,
"usages": 1,
"profile_type": "autologin",
"username": "niccolo@paganini.it",
"comment": "connected from my iPhone"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none | |
» lifetime | body | integer | false | Optional lifetime in seconds that the token should be valid for. Longer lifetimes than default require admin privileges. |
» usages | body | integer | false | Optional number of usages that this token can be used to generate a profile. Defaults to a single use if not provided. Specifying more than one usage requires admin privileges. |
» profile_type | body | true | Specifies the connection profile type. | |
» username | body | false | A case-sensitive username. If this differs from the one associated with the auth token, admin privileges may be required for certain operations. | |
» comment | body | string | false | Optional comment for the profile that will be stored with the token and applied when the profile is generated. |
Enumerated Values
Parameter | Value |
|---|---|
» profile_type | autologin |
» profile_type | userlogin |
» profile_type | generic |
» profile_type | epki-generic |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Token URL generated successfully. | string | |
400 | Token url could not be generated. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"lifetime": 1,
"usages": 1,
"profile_type": "autologin",
"username": "niccolo@paganini.it",
"comment": "connected from my iPhone"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/token-url',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});enumerateTokenIds
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | List of all valid profile token URLs. | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» profileTokens | false | none | [A token (typically one-time use) that can be used to retrieve a connection profile from Access Server. Access Server] | |
»» token | string | false | none | the unique string that identifies the token |
»» username | string | false | none | the username this token will generate the profile for |
»» expires | string(date-time) | false | none | the token is only valid until this time |
»» profile_type | false | none | Specifies the connection profile type. | |
»» usages | integer | false | none | how often this token can be used to retrieve a profile |
»» comment | string | false | none | optional comment that will be applied to the profile when generated using this token |
Enumerated Values
Property | Value |
|---|---|
profile_type | autologin |
profile_type | userlogin |
profile_type | generic |
profile_type | epki-generic |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/token-url/list',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"profileTokens": [
{
"token": "a4aL62OFooAjPu4wu6MQCvcmY070hu8B",
"username": "arne@openvpn.net",
"expires": "2019-08-24T14:15:22Z",
"profile_type": "autologin",
"usages": 1,
"comment": "connected from my iPhone"
}
]
}deleteProfileSerial
Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
serial | path | true | none |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Profiles were successfully deleted. | Inline | |
400 | The profile could not be deleted. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» message | string | false | none | describes status of deletion |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/profiles/delete/{serial}',
{
method: 'POST',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"message": "string"
}deleteProfileUser
Body parameter
{
"users": [
"niccolo@paganini.it"
],
"filter": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» users | body | [username] | false | user name list whose connection profiles will be deleted. |
» filter | body | string | false | will delete all profiles that have the argument as a substring |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Profiles were successfully deleted. | Inline | |
400 | The user profiles were not deleted. | ||
404 | The user profiles were not found. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» message | string | false | none | describes status of deletion |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"users": [
"niccolo@paganini.it"
],
"filter": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/profiles/delete-user',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"message": "string"
}deleteProfile
Body parameter
[
"1708464983752887'"
]Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The request was successfully executed. The status for each profile is included in the response. | Inline | |
400 | could not delete the profile |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» message | any | false | none | describes status of deletion |
» response | object | true | none | hash map that maps the requested delete request to a result |
»» additionalProperties | false | none | none |
Enumerated Values
Property | Value |
|---|---|
additionalProperties | {“204”:null,“description”:“profile successfully deleted”} |
additionalProperties | {“404”:null,“description”:“profile to be deleted was not found”} |
additionalProperties | {“403”:null,“description”:“profile to be deleted is not owned by the user or another error”} |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '[
"1708464983752887'"
]';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/profiles/delete',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"message": null,
"response": {
"21": 204,
"7127317": 404
}
}vpnca
Endpoints for managing the certificate authorities (CAs) used to sign VPN server and client certificates.
getVPNCas
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The request was successful. The response includes an array of CAs with details. | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
anonymous | [allOf] | false | none | none |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» anonymous | false | none | none | |
»» serial | certificateSerial(int64) | true | none | A string representing the certificate serial number. A string is used instead of an integer to avoid issues with large values in JavaScript, which cannot reliably handle integers larger than 52 bits. |
»» common_name | true | none | The certificate common name (CN). | |
»» algorithm | true | none | Specifies the algorithm used for private/public key pair in an X.509 certificate. This is an identifier such as ecp384r1, secp256r1, or secp512r1. For algorithms with variable key lengths, the length is included in the name (e.g., rsa3072). | |
»» not_before | string(date-time) | true | none | Earliest time the certificate is valid |
»» not_after | string(date-time) | true | none | Latest time the certificate is valid |
»» self_signed | boolean | false | none | Whether this certificate is self-signed. Typically only root CA certificates are self-signed. |
»» signing_ca | string(int64) | false | none | The certificate authority that has signed this certificate. For self-signed certificate authorities this value is absent. This attribute is only present for certificates that are managed by the internal PKI of Access Server and the APIs that deal and return information about these. This is also represented as a string rather than integer to avoid problems with JavaScript numbers always being double. |
»» signing_ca_cn | string | false | none | The common name of certificate authority that has signed this certificate. For self-signed certificate authorities this value is absent. This attribute is only present for certificates that are managed by the internal PKI of Access Server and the APIs that deal and return information about these. |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» anonymous | object | false | none | none |
»» cert_type | true | none | The type of certificate. | |
»» client_profiles | integer | true | none | the number of VPN client profiles are issued by this CA. |
Enumerated Values
Property | Value |
|---|---|
cert_type | ca |
cert_type | old_ca |
cert_type | cross_ca |
cert_type | client |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/ca/vpn/list',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});[
{
"serial": "1708464983752887'",
"common_name": "OpenVPN VPN server CA",
"algorithm": "rsa2048",
"not_before": "2020-03-27",
"not_after": "2030-03-26",
"self_signed": true,
"signing_ca": "123",
"signing_ca_cn": "RootCA",
"cert_type": "ca",
"client_profiles": 0
}
]addCaGeneration
Body parameter
{
"algorithm": "secp384r1",
"common_name": "my shiny new CA"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none | |
» algorithm | body | false | Specifies the algorithm used for private/public key pair in an X.509 certificate. This is an identifier such as ecp384r1, secp256r1, or secp512r1. For algorithms with variable key lengths, the length is included in the name (e.g., rsa3072). | |
» common_name | body | false | The certificate common name (CN). |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
201 | The new CA was successfully created | None | |
400 | The request was invalid. | ||
This may occur if the selected algorithm is not allowed, the common name is too long, contains invalid characters, or already exists. | |||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"algorithm": "secp384r1",
"common_name": "my shiny new CA"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/ca/vpn/create',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}delete_ca_vpn{serial}
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The CA was successfully deleted | None | |
400 | The CA could not be deleted. | ||
This may occur if the CA still has client certificates or if it is the only CA in the system. | |||
403 | Only admin users are allowed to use this API endpoint. | ||
404 | The specified CA was not found |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/ca/vpn/{serial}',
{
method: 'DELETE',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
serial | path | true | none | |
delete_clients | query | boolean | false | will force the deletion of the CA (and all client certificates) |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}CaSupportedAlgorithms
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Returns a list of allowed public/private key algorithms. | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
anonymous | false | none | [Specifies the algorithm used for private/public key pair in an X.509 certificate. This is an identifier such as ecp384r1, secp256r1, or secp512r1. For algorithms with variable key lengths, the length is included in the name (e.g., rsa3072).] |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/ca/allowed-algorithms/list',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});[
"rsa2048",
"rsa3072",
"rsa4096",
"ed448",
"brainpoolP384r1",
"brainpoolP512r1",
"secp2256k1",
"Ed25519"
]info
Endpoints for querying various aspects of the running server and its current status.
certificateInfo
Body parameter
{
"certificate": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» certificate | body | false | A certificate in PEM format, beginning with |
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Returns detailed information about the X509 certificate. | ||
400 | The provided certificate could not be parsed, or encountered other problems. | ||
403 | only admin users are allowed to use this API | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"certificate": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/certificate/info',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"serial": "1708464983752887'",
"common_name": "OpenVPN VPN server CA",
"algorithm": "rsa2048",
"not_before": "2020-03-27",
"not_after": "2030-03-26",
"self_signed": true,
"signing_ca": "123",
"signing_ca_cn": "RootCA",
"sha256fp": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"subj_alt_names": [
"DNS:foo.example.com",
"DNS:www.openvpn.net",
"IP:1.2.3.4"
],
"subject": [
"C=US",
"ST=Maryland",
"L=Pasadena",
"O=DevOrg",
"OU=FreeSoft",
"OU=non-free soft",
"CN=rogue software department"
],
"issuer": [
"C=US",
"ST=Maryland",
"L=Pasadena",
"O=DevOrg",
"OU=FreeSoft",
"OU=non-free soft",
"CN=rogue software CA department"
],
"ca": true
}checkPrivateKey
Body parameter
{
"certificate": "string",
"private_key_passphrase": "string",
"private_key": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | any | false | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Both the private key and certificate were successfully parsed. The response indicates whether the private key matches the certificate. | Inline | |
400 | The certificate or private key could not be parsed. | ||
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» status | boolean | false | none | true if the private key matches the certificate |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"certificate": "string",
"private_key_passphrase": "string",
"private_key": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/certificate/check-private-key',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"status": true
}post__certificate_check-against-ca-roots
Body parameter
{
"certificate": "string",
"chain": "string",
"ca_roots": [
"string"
]
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The certificate has been successfully verified against the provided CA certificates. The response contains the trust chain that was found. | Inline | |
400 | The certificate failed verification. Details are provided in the response. | ||
403 | Only admin users are allowed to use this API endpoint. |
const inputBody = '{
"certificate": "string",
"chain": "string",
"ca_roots": [
"string"
]
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/certificate/check-against-ca-roots',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"chain": [
{
"serial": "1708464983752887'",
"common_name": "OpenVPN VPN server CA",
"algorithm": "rsa2048",
"not_before": "2020-03-27",
"not_after": "2030-03-26",
"self_signed": true,
"signing_ca": "123",
"signing_ca_cn": "RootCA",
"sha256fp": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"subj_alt_names": [],
"subject": [],
"issuer": [],
"ca": true
}
]
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» certificate | body | true | A certificate in PEM format, beginning with | |
» chain | body | false | A certificate in PEM format, beginning with | |
» ca_roots | body | false | a list of CA certificates that should be used as trusted certificate authorities. If left empty AS will use the system certificates root CAs. This are very similar but not always identical to a browser trust store. |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» chain | [allOf] | false | none | [Provides more information about a certificate.] |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»» anonymous | false | none | none | |
»»» serial | certificateSerial(int64) | true | none | A string representing the certificate serial number. A string is used instead of an integer to avoid issues with large values in JavaScript, which cannot reliably handle integers larger than 52 bits. |
»»» common_name | true | none | The certificate common name (CN). | |
»»» algorithm | true | none | Specifies the algorithm used for private/public key pair in an X.509 certificate. This is an identifier such as ecp384r1, secp256r1, or secp512r1. For algorithms with variable key lengths, the length is included in the name (e.g., rsa3072). | |
»»» not_before | string(date-time) | true | none | Earliest time the certificate is valid |
»»» not_after | string(date-time) | true | none | Latest time the certificate is valid |
»»» self_signed | boolean | false | none | Whether this certificate is self-signed. Typically only root CA certificates are self-signed. |
»»» signing_ca | string(int64) | false | none | The certificate authority that has signed this certificate. For self-signed certificate authorities this value is absent. This attribute is only present for certificates that are managed by the internal PKI of Access Server and the APIs that deal and return information about these. This is also represented as a string rather than integer to avoid problems with JavaScript numbers always being double. |
»»» signing_ca_cn | string | false | none | The common name of certificate authority that has signed this certificate. For self-signed certificate authorities this value is absent. This attribute is only present for certificates that are managed by the internal PKI of Access Server and the APIs that deal and return information about these. |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»» anonymous | object | false | none | none |
»»» sha256fp | certificateFingerprint(sha256) | false | none | The SHA256 hash of the certificate body, commonly refferred to as the fingerprint of the certificate. |
»»» subj_alt_names | [string] | false | none | provides a list of the subjectAlternative attributes of the certificate |
»»» subject | [string] | false | none | the full subject of the certificate and not only the CN |
»»» issuer | [string] | false | none | the full subject of the issuer. Note that this field cannot be trusted without verifying the signature on the certificate itself. Using this field should come with extreme care. |
»»» ca | boolean | false | none | Whether the certificate represents a certificate authority |
»»» self_signed | boolean | false | none | the signature of the certificate is valid against its own public key |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
get__eula
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Returns the current EULA, its version, and whether the user has accepted it. | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/eula',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"eula": "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ...",
"eula_web": "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ...",
"eula_version_as": 7,
"eula_web_hash": "36D7D51F474A84A2A30A41BC92CBA5D9D65F756484011D6F58B9D667F8DBBE9C",
"eula_accepted": true
}Response Schema
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
serverInterfaces
Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
no_loopback | query | boolean | false | if true exclude loopback interfaces |
Responses
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
anonymous | false | none | [Describes a Linux network interface along with its associated primary networks.] | |
» name | any | false | none | the name identifying the interface |
» networks | [IPsubNet] | false | none | IP addresses assigned to the interface |
»» ipv6 | boolean | false | none | whether this describes an IPv4 or an IPv6 subnet |
»» netip | string | false | none | the network IP address. |
»» prefix_length | integer | false | none | length of the prefix in CIDR notation |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/server/interfaces',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});[
{
"name": "eth0",
"networks": [
{},
{},
{}
]
}
]get__server_info
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Returns information about the running Access Server instance. | ||
403 | only admin users are allowed to use this API | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/server/info',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"version": "2.13.0-internal",
"build": "18eba991",
"web_version": "2.12.7-82fda2",
"web_override": true,
"client_version": "27",
"os_distribution": "Ubuntu 24.04.6 LTS",
"architecture": "arm64",
"cores": 0,
"system_cores": null,
"os_hostname": "access-server-os-hostname"
}get__server_dns
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | DNS servers | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/server/dns',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});[
{
"ip_addr": "string",
"ipv6": true
}
]Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» ip_addr | string | false | none | IP address of a DNS server |
» ipv6 | boolean | false | none | whether this describes an IPv4 or an IPv6 address |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
get__vpn_dco-module
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Returns the DCO module status and version. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/vpn/dco-module',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"available": true,
"version": "0.2.20230323"
}post__helper_status-overview
Body parameter
{
"names": [
"vpn.server.cipher"
]
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Consolidated status overview data. | Inline | |
400 | Something went wrong | ||
403 | Only admin users are allowed to use this API endpoint. |
const inputBody = '{
"names": [
"vpn.server.cipher"
]
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/helper/status-overview',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"configuration_items": {
"total": 0,
"items": [
{}
]
},
"server_info": {
"version": "2.13.0-internal",
"build": "18eba991",
"web_version": "2.12.7-82fda2",
"web_override": true,
"client_version": "27",
"os_distribution": "Ubuntu 24.04.6 LTS",
"architecture": "arm64",
"cores": 0,
"system_cores": null,
"os_hostname": "access-server-os-hostname"
},
"dco_module": {
"available": true,
"version": "0.2.20230323"
},
"eula_status": {
"eula_version_as": 7,
"eula_web_hash": "36D7D51F474A84A2A30A41BC92CBA5D9D65F756484011D6F58B9D667F8DBBE9C",
"eula_accepted": true
}
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» names | body | false | list of configuration items that should be retrieve from the active configuration |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» configuration_items | object | false | none | Response from the /config/{activeprofile}/items part of the query |
»» total | integer | false | none | total number of profiles that match if pagination is not in effect, this matches the size of the provided array |
»» items | [allOf] | false | none | [Represents a single configuration item. Check the derived_from field to see whether it’s user-set, default, or inherited.] |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»» anonymous | object | false | none | none |
»»»» name | true | none | The configuration value's key. | |
»»»» derived_from | true | none | Indicates the source from which the current value was derived, such as default or user-set. | |
»»»» type | string | false | none | Determines the value type of this configuration item. This also implies which of the different value attributes are expected to be present on this configuration item. |
»»»» description | string | false | none | A user readable description of the configuration item that gives a user an understandable. This item can be absent for custom configuration values. |
»»»» category | string | true | none | Different items have different visibility/category that should be taken into account when presenting them to the user. This key informs the UI if a variable is deprecated but still evaluated (deprecated), deprecated and removed (removed), normal, advanced (a value that for normal operation of OpenVPN Access Server should need to be changed as it is typically reserved for some corner-case or speciality configurations) or is a calculated value that is readonly as it is calculated from other configuration items but is not modifiable by the user (derived). Items that have a type of required often do not have a default value but must be set in order for Access to correctly work (e.g. host.name). Removed values should be only shown by the UI if the are set by the user. |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»» anonymous | any | false | none | none |
oneOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»» anonymous | false | none | A server configuration setting expressed as an integer. |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»»» anonymous | object | false | none | none |
»»»»»» value | integer | false | none | none |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»»» anonymous | false | none | none | |
»»»»»» default_value | integer | false | none | The default value for the configuration. |
»»»»»» max_value | integer | false | none | A hint of maximum allowed value |
»»»»»» min_value | integer | false | none | A hint for minimum allowed value |
xor
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»» anonymous | false | none | A configuration value that is expressed as an integer. |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»»» anonymous | false | none | none |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»»» anonymous | object | false | none | none |
»»»»»» value | string | false | none | none |
»»»»»» invalid_value | boolean | false | none | This is set to True to indicate that the value is invalid as integer. This happens if the value in the configuration database itself has an invalid value. The field value will in this case be a string. |
xor
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»» anonymous | false | none | none | |
»»»»» value | boolean | false | none | none |
»»»»» default_value | boolean | false | none | The default value for the configuration. |
xor
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»» anonymous | false | none | A server configuration setting expressed as a string. Only one of | |
»»»»» value | string | false | none | the value of this string configuration |
»»»»» redacted_value | string | false | none | the real value of this configuration key is not present because it is a private key or password. The value of this string will give an indication of the redacted value. |
»»»»» default_value | string | false | none | The default value for the configuration. |
»»»»» allowed_values | [string] | false | none | if present this array has a list of the allowed values |
»»»»» type_hint | string | false | none | if present, this type hint denotes this configuration value to contain a special type of value, so the UI can do additional verification to ensure the user input matches this type |
xor
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»»» anonymous | false | none | A configuration key unknown to the backend, possible user-defined or carried over from a new version during downgrade. | |
»»»»» value | string | false | none | none |
continued
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» server_info | false | none | none | |
»» version | string | false | none | the version number of Access Server |
»» build | string | false | none | the build of Access Server. |
»» web_version | string | false | none | the build version number of Access Server UI |
»» web_override | boolean | false | none | if true the version of the web ui that is used comes from an override-web.zip instead of the bundled version |
»» client_version | string,null | false | none | version of the embedded client package. |
»» os_distribution | string | false | none | a human readable identifier of the current (Linux) distribution like PRETTY_NAME from /etc/os-release |
»» architecture | string | false | none | the CPU architecture |
»» cores | integer | false | none | the number of cores available to OpenVPN Access server. Typically identical to system_cores. |
»» system_cores | any | false | none | the number of cores visible to the operating system |
»» os_hostname | string | false | none | Operating system’s hostname |
» dco_module | false | none | none | |
»» available | boolean | true | none | whether AS detected an installed and working data channel offloading kernel module |
»» version | string | true | none | version of the module if available |
» eula_status | false | none | none | |
»» eula_version_as | integer | false | none | The version of the AS EULA |
»» eula_web_hash | string(sha256) | false | none | A SHA256 string in hex format without : separators |
»» eula_accepted | boolean | false | none | indicates whether the config setting (aui.eula_version) has the same value as eula_version_as |
Enumerated Values
Property | Value |
|---|---|
derived_from | default |
derived_from | local_db |
derived_from | cluster_db |
derived_from | mysql_standalone_db |
derived_from | as_conf |
derived_from | environment |
derived_from | runtime |
derived_from | other |
type | custom |
type | integer |
type | boolean |
type | string |
category | deprecated |
category | removed |
category | normal |
category | required |
category | derived |
category | advanced |
category | custom |
type_hint | ipv4Address |
type_hint | ipv6Address |
type_hint | ipAddress |
type_hint | hostname |
type_hint | pemCertificate |
type_hint | pemPrivateKey |
architecture | arm64 |
architecture | amd64 |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
license
Endpoints for examining and setting licensing of the AS instance
licenseInfo
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Licensing information for the Access Server instance. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/info',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"licensing_type": "unlicensed",
"current_cc": 3,
"max_cc": 13,
"fixed_licenses": [
{
"expiry": "2019-08-24T14:15:22Z",
"key": "string",
"max_cc": 0
}
]
}checkSubscription
Body parameter
{
"subscription": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» subscription | body | string | true | The subscription file. This is either a string containing a json object or a base64 encoding of the json object. |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Subscription test result returned successfully. | ||
400 | The license key format is invalid, or an error occurred while processing the test. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"subscription": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/subscription/test',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"agent_id'": "13014502862141447248",
"agent_disabled": true,
"cc_limit": 13,
"error": "string",
"fallback_cc'": 2,
"grace_period": 30,
"last_successful_update": "2019-08-24T14:15:22Z",
"total_cc": 0,
"name": "Test subscription for development",
"subkey": "ASUYHgkSWvVQFZhJXVdgtEa_AStctYuHirYZeFbZjLvQCWCaViVamXwL_7a289be35f6987c9aec4585c922a740c1b7620d5",
"billing_id": "tctYuHirYZeFbZjLvQC",
"next_update": "2019-08-24T14:15:22Z",
"updates_failed": 0,
"notes": [
"Subscription will expire on 1/2/3",
"Maximum allowed concurrent connections might be limited to 23 by the 'subscription.local_cc_limit' setting"
],
"overdraft": true,
"server": "asb.sts.openvpn.net",
"type": "-",
"state": "'prop' { 'certfp': 'LfLIlGKsZds4940SOmsj5Q+xunxh21yx0+3DEXK2bB4=',\n - 'id': 'mynode.cloud.example.com',\n - 'ip': '178.203.239.243',\n - 'ip6': '2a02:908:2220:a200:5054:ff:fef2:d165',\n - 'oshost': 'noble-as' }\n",
"props": null
}loadSubscription
Body parameter
{
"subscription": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» subscription | body | string | true | The subscription file. This is either a string containing a json object or a base64 encoding of the json object. |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Subscription has been successfully loaded. | None | |
400 | The license key format is invalid, or an error occurred while applying the subscription. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"subscription": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/subscription',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}deactivateSubscription
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Subscription has been successfully deactivated. | None | |
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/subscription',
{
method: 'DELETE',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});activateFixedLicenseOnline
Body parameter
{
"license": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» license | body | string | true | The license file |
The license format is invalid, or an error occurred during activation.
{
"message": "License not found on server"
}standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Fixed license key successfully activated. | None | |
400 | The license format is invalid, or an error occurred during activation. | ||
403 | Only admin users are allowed to use this API endpoint. | ||
503 | License server is unreachable. | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"license": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/fixed-license/online-activation',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});activateFixedLicenseOffline
Body parameter
license: stringParameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | false | none |
» license | body | string | true | The license file |
The license format is invalid, or an error occurred during activation.
{
"message": "Fixed license already expired"
}standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Fixed license key has been successfully activated. | None | |
400 | The license format is invalid, or an error occurred during activation. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"license": "string"
}';
const headers = {
'Content-Type':'multipart/form-data',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/fixed-license/offline-activation',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});licenseGetMachineId
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Machine ID file returned successfully. | string | |
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'text/plain',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/license/machine-id',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});"string"proxy
A pseudo-endpoint that explains the proxying mechanism used to route API requests to other OpenVPN Access Server backend nodes in a clustered setup.
post__proxy
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
502 | Communication problem with the target backend node (other than a timeout) or the X-OpenVPN-AS-Node is not in the list of backend servers. | ||
504 | Proxying the request to the target node timed out. | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-AS-Node':'string',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/proxy',
{
method: 'POST',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
X-OpenVPN-AS-Node | header | string | false | Optional header used to determine which backend node the request should be forwarded to. |
Detailed descriptions
X-OpenVPN-AS-Node: Optional header used to determine which backend node the request should be forwarded to. The value must match the node name, not the node api_endpoint. See the /proxy pseudo-endpoint for a description of the proxying mechanism.
cluster
Endpoints for configuring, monitoring, and managing an Access Server cluster, including node setup and status checks.
clusterListNodes
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | List of cluster nodes. | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» nodes | object | false | none | holds a dictionary of all the nodes that are part of the cluster |
»» additionalProperties | any | false | none | none |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»» anonymous | false | none | Describes a node in the cluster. The certificate field represents the certificate the node presents on its api_endpoint and is used to verify the node's identity. | |
»»»» name | string | true | none | the name that uniquely identifies the cluster node [node_name] |
»»»» api_endpoint | false | none | The API endpoint used to communicate with a specific node. Must be in the format https://ip-or-hostname:port. The https scheme is required because the certificateFingerprint is used by the HTTPS client to verify the identity of the node. | |
»»»» certificate_fingerprint | certificateFingerprint(sha256) | false | none | The SHA256 hash of the certificate body, commonly refferred to as the fingerprint of the certificate. |
and
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»»» anonymous | object | false | none | none |
»»»» restart_pending | boolean | false | none | Indicates if a node has a pending restart. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/nodes/list',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"nodes": {
"property1": {
"name": "vienna.example.com",
"api_endpoint": "https://node1:945",
"certificate_fingerprint": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"restart_pending": true
},
"property2": {
"name": "vienna.example.com",
"api_endpoint": "https://node1:945",
"certificate_fingerprint": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"restart_pending": true
}
}
}rrdnshostname
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The cluster DNS hostname was updated successfully on all nodes. | None | |
400 | Failed to update the cluster DNS hostname due to a configuration error. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/rr-dns-hostname',
{
method: 'PUT',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}clustergetprops
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Successfully retrieved cluster properties from the cluster | Inline | |
400 | Getting the cluster properties failed | ||
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» props | object | false | none | holds a dictionary of all props of the cluster |
»» additionalProperties | false | none | Properties shared across all nodes in an Access Server cluster. | |
»»» rr_dns_hostname | string | false | none | the Round-Robin hostname that uniquely identifies the cluster |
»»» rr_dns_new_nodes | boolean | false | none | if true, use rr_dns_hostname as node hostname for new nodes joining the cluster |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/props',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"props": {
"property1": {
"rr_dns_hostname": "cluster.example.com",
"rr_dns_new_nodes": true
},
"property2": {
"rr_dns_hostname": "cluster.example.com",
"rr_dns_new_nodes": true
}
}
}clustersetprops
Body parameter
{
"rr_dns_hostname": "cluster.example.com",
"rr_dns_new_nodes": true
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none | |
» rr_dns_hostname | body | string | false | the Round-Robin hostname that uniquely identifies the cluster |
» rr_dns_new_nodes | body | boolean | false | if true, use rr_dns_hostname as node hostname for new nodes joining the cluster |
Setting the cluster properties failed.
{
"message": "rr_dns_hostname has invalid characters in it"
}standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The cluster properties were successfully updated in the database. | None | |
400 | Setting the cluster properties failed. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"rr_dns_hostname": "cluster.example.com",
"rr_dns_new_nodes": true
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/props',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});post__cluster_join
Body parameter
{
"name": "vienna.example.com",
"api_endpoint": "https://node1:945",
"certificate_fingerprint": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"mysql_uri_parts": {
"host": "string",
"port": 1,
"username": "string",
"password": "string"
}
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The server successfully joined the cluster. | None | |
400 | The server failed to join the cluster. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"name": "vienna.example.com",
"api_endpoint": "https://node1:945",
"certificate_fingerprint": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"mysql_uri_parts": {
"host": "string",
"port": 1,
"username": "string",
"password": "string"
}
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/join',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}post__cluster_create
Body parameter
{
"name": "vienna.example.com",
"api_endpoint": "https://node1:945",
"certificate_fingerprint": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"mysql_uri_parts": {
"host": "string",
"port": 1,
"username": "string",
"password": "string"
},
"rr_dns_hostname": "cluster.example.com",
"rr_dns_new_nodes": true,
"rr_update_node": true
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The cluster was created and the current node joined successfully. | None | |
400 | The cluster could not be created. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"name": "vienna.example.com",
"api_endpoint": "https://node1:945",
"certificate_fingerprint": "36:D7:D5:1F:47:4A:84:A2:A3:0A:41:BC:92:CB:A5:D9:D6:5F:75:64:84:01:1D:6F:58:B9:D6:67:F8:DB:BE:9C",
"mysql_uri_parts": {
"host": "string",
"port": 1,
"username": "string",
"password": "string"
},
"rr_dns_hostname": "cluster.example.com",
"rr_dns_new_nodes": true,
"rr_update_node": true
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/create',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}post__cluster_leave
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The node was successfully removed from the cluster. | None | |
400 | The request to leave the cluster failed. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/cluster/leave',
{
method: 'POST',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}put__database_convert
Body parameter
{
"host": "string",
"port": 1,
"username": "string",
"password": "string"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The database was successfully converted, and the configuration updated. | None | |
400 | The database conversion failed. | ||
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"host": "string",
"port": 1,
"username": "string",
"password": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/database/convert',
{
method: 'PUT',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | false | none | |
» host | body | string | true | none |
» port | body | integer | true | none |
» username | body | string | true | none |
» password | body | string | true | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}maintenance
Endpoints for performing server maintenance tasks, such as restarting Access Server or its services.
get__support_report
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Support report generated successfully. The output is the same as running | string | |
403 | Only admin users are allowed to use this API endpoint. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'text/plain',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/support/report',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});"string"post__server_restart
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Server restart successfully scheduled | None | |
400 | Server has some misconfiguration and restart is not scheduled | ||
403 | User does not have admin permission | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/server/restart',
{
method: 'POST',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
restartMode | query | false | none | |
group | query | string | false | for the warm restart mode, this limits the services to the listed groups to be restarted |
Enumerated Values
Parameter | Value |
|---|---|
restartMode | cold |
restartMode | warm |
restartMode | dry_run |
restartMode | systemctl |
restartMode | server_agent |
serverStatus
Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Server and status returned successfully | ||
403 | User does not have admin permission | None |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/server/status',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"last_restarted": "2019-08-24T14:15:22Z",
"service_status": {
"property1": {
"status": "on",
"error": []
},
"property2": {
"status": "on",
"error": []
}
},
"auth_module_status": {
"property1": "on",
"property2": "on"
}
}configurationProfile
API to manage Access Server main configuration database. These endpoints allow you to retrieve, update, and manage configuration values stored in the active or named configuration profiles.
enumerateConfigurationProfileList
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | A list of all configuration profiles on Access Server | Inline | |
403 | Only admin users are allowed to use this API endpoint. |
Response Schema
Status Code 200
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» active_profile | false | none | The configuration profile name. The default profile is typically DEFAULT. Additional profiles allow for staging changes or creating backups. | |
» profiles | false | none | A list of all configuration profiles on Access Server |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/config-profile/list',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"active_profile": "default",
"profiles": [
"default",
"heaven",
"hades",
"olymp"
]
}configurationProfileDelete
Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
profile | path | true | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
204 | Configuration profile was successfully deleted | None | |
400 | profile deletion would violate some constraints like deleting the active profile | ||
403 | Only admin users are allowed to use this API endpoint. | ||
404 | Specified configuration profile was not found. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/config-profile/{profile}',
{
method: 'DELETE',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}configurationProfileCreate
Body parameter
{
"profile": "string",
"copy_from": "string"
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
body | body | object | true | none |
» profile | body | true | The configuration profile name. The default profile is typically DEFAULT. Additional profiles allow for staging changes or creating backups. | |
» copy_from | body | false | The configuration profile name. The default profile is typically DEFAULT. Additional profiles allow for staging changes or creating backups. |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
201 | The configuration profile was created successfully. | None | |
400 | The profile name is invalid, or another error occurred during creation. | ||
403 | Only admin users are allowed to use this API endpoint. | ||
404 | The specified |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const inputBody = '{
"profile": "string",
"copy_from": "string"
}';
const headers = {
'Content-Type':'application/json',
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/config-profile',
{
method: 'POST',
body: inputBody,
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}validateConfigProfile
Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
profile | path | true | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The configuration profile is valid with no detected errors. | None | |
400 | The profile contains validation issues. | ||
403 | Only admin users are allowed to use this API endpoint. | ||
404 | Configuration profile does not exist. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/config-profile/{profile}/validate',
{
method: 'GET',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});{
"reason": "Your password must not include parts of Cthulhu's chant.",
"title": "Password validation failed"
}RunSetActiveProfile
Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
profile | path | true | The name of the profile to activate. | |
restartMode | query | false | The restart mode that should be used to restart the server. |
Enumerated Values
Parameter | Value |
|---|---|
restartMode | cold |
restartMode | warm |
restartMode | dry_run |
restartMode | systemctl |
restartMode | server_agent |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | Success. No errors in the profile are detected and the new profile is being set. | None | |
400 | validation of the profile encountered some problems or some other error occurred. See error reason for more details. | ||
403 | Only admin users are allowed to use this API endpoint. | ||
404 | the requested configuration profile was not found. |
To perform this operation, you must be authenticated by means of one of the following methods: AuthToken
const headers = {
'Accept':'application/json',
'X-OpenVPN-As-AuthToken':'API_KEY'
};
fetch('/api/config-profile/{profile}/set-active',
{
method: 'POST',
headers: headers
})
.then(function(res) {
return res.json();
}).then(function(body) {
console.log(body);
});getConfigItems
Body parameter
{
"names": [
"vpn.server.cipher"
],
"include_pattern_keys": false
}Parameters
Name | In | Type | Required | Description |
|---|---|---|---|---|
configurationProfile | path | true | The name of the configuration profile to list items from. | |
body | body | any | false | none |
standard response when there insufficient rights to use an API.
{
"message": "Insufficient privileges to use this API"
}Responses
Status | Meaning | Description | Schema |
|---|---|---|---|
200 | The list of configuration items was successfully returned. | Inline | |
403 | Only admin users are allowed to use this API endpoint. | ||
404 | Configuration profile does not exist. |
Response Schema
Status Code 200
A list of all or subset of profiles
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
» total | integer | false | none | total number of profiles that match if pagination is not in effect, this matches the size of the provided array |
» items | [allOf] | false | none | [Represents a single configuration item. Check the derived_from field to see whether it’s user-set, default, or inherited.] |
allOf
Name | Type | Required | Restrictions | Description |
|---|---|---|---|---|
»» anonymous | object | false | none | none |
»»» name | true | none | The configuration value's key. | |
»»» derived_from | true | none | Indicates the source from which the current value was derived, such as default or user-set. | |
»»» type | string | false | none | Determines the value type of this configuration item. This also implies which of the different value attributes are expected to be present on this configuration item. |
»»» description | string | false | none | A user readable description of the configuration item that gives a user an understandable. This item can be absent for custom configuration values. |
[...]
